/*
 * 
 * Copyright 2004 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * The contents of this file are subject to the Sun Community Source
 * License v3.0/Jini Technology Specific Attachment v 1.0 (the
 * "License"). You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://wwws.sun.com/software/jini/licensing/SCSL3_JiniTSA1.html.
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Reference Code is Jini Technology Core Platform code, v2.0. The
 * Developer of the Reference Code is Sun Microsystems, Inc.
 * 
 * Contributor(s): Sun Microsystems, Inc.
 * 
 * The contents of this file comply with the Jini Technology Core
 * Platform Compatibility Kit, v2.0A.
 * 
 * Tester(s): Sun Microsystems, Inc.
 * 
 * Test Platform(s):
 * Java 2 SDK, Standard Edition, Version 1.4.2_03 for Solaris(TM)SPARC/x86
 * Java 2 SDK, Standard Edition, Version 1.4.2_03 for Linux (Intel x86)
 * Java 2 SDK, Standard Edition, Version 1.4.2_03 for Windows (Intel Platform)
 * 
 */
package com.sun.jini.outrigger;

import java.util.LinkedList;
import java.util.logging.Level;
import java.util.logging.Logger;

import net.jini.id.Uuid;

/**
 * Logs expiration of leases and asynchronously persists them to disk.
 */
class ExpirationOpQueue extends Thread {
    /** <code>true</code> if we should stop */
    private boolean dead;

    /** The queue of expirations to log */
    private final LinkedList queue = new LinkedList();

    /** The server we are working for */
    private final OutriggerServerImpl server;

    /** Logger for logging exceptions */
    private static final Logger logger = 
	Logger.getLogger(OutriggerServerImpl.leaseLoggerName);

    /**
     * Create a new <code>ExpirationOpQueue</code> that
     * will handle lease expiration logging for the 
     * specified server.
     * @param server the <code>OutriggerServerImpl</code> to 
     *        log for.
     */
    ExpirationOpQueue(OutriggerServerImpl server) {
	super("Expiration Op Queue");
	this.server = server;
    }

    /**
     * Enqueue the logging of the expiration of the specified lease.
     * @param cookie The cookie of the lease that has expired.
     */
    synchronized void enqueue(Uuid cookie) {
	queue.add(cookie);
	notifyAll();
    }

    /**
     * Stop the queue
     */
    synchronized void terminate() {
	dead = true;
	notifyAll();
    }

    public void run() {
	while (!dead) { // ok not to lock since it starts false
	    try {
		final Uuid cookie;
		synchronized (this) { 
		    while (!dead && queue.isEmpty()) {
			wait();
		    }
		    
		    if (dead)
			return;

		    cookie = (Uuid)queue.removeFirst();
		}
		
		server.cancelOp(cookie, true);
	    } catch (Throwable t) {
		logger.log(Level.INFO, "ExpirationOpQueue.run encountered " +
			   t.getClass().getName() + ", continuing", t);
	    }
	}
    }
}


